"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var material_1 = require("@angular/material");
var core_2 = require("@ng-dynamic-forms/core");
var dynamic_material_form_const_1 = require("./dynamic-material-form.const");
var DynamicMaterialFormControlComponent = /** @class */ (function (_super) {
    __extends(DynamicMaterialFormControlComponent, _super);
    function DynamicMaterialFormControlComponent(changeDetectorRef, validationService) {
        var _this = _super.call(this, changeDetectorRef, validationService) || this;
        _this.changeDetectorRef = changeDetectorRef;
        _this.validationService = validationService;
        _this._showCharacterCount = false;
        _this.bindId = true;
        _this.context = null;
        _this.hasErrorMessaging = false;
        _this.blur = new core_1.EventEmitter();
        _this.change = new core_1.EventEmitter();
        _this.focus = new core_1.EventEmitter();
        return _this;
    }
    DynamicMaterialFormControlComponent_1 = DynamicMaterialFormControlComponent;
    Object.defineProperty(DynamicMaterialFormControlComponent.prototype, "showCharacterHint", {
        get: function () {
            return !!(this._showCharacterCount && this.model.maxLength && this.characterCount);
        },
        set: function (value) {
            this._showCharacterCount = value;
        },
        enumerable: true,
        configurable: true
    });
    DynamicMaterialFormControlComponent.prototype.ngOnChanges = function (changes) {
        _super.prototype.ngOnChanges.call(this, changes);
        if (changes["model"]) {
            this.type = DynamicMaterialFormControlComponent_1.getFormControlType(this.model);
        }
    };
    Object.defineProperty(DynamicMaterialFormControlComponent.prototype, "characterCount", {
        get: function () {
            return this.mdInput ? this.mdInput.value.length : null;
        },
        enumerable: true,
        configurable: true
    });
    DynamicMaterialFormControlComponent.getFormControlType = function (model) {
        switch (model.type) {
            case core_2.DYNAMIC_FORM_CONTROL_TYPE_ARRAY:
                return 1 /* Array */;
            case core_2.DYNAMIC_FORM_CONTROL_TYPE_CHECKBOX:
                return 2 /* Checkbox */;
            case core_2.DYNAMIC_FORM_CONTROL_TYPE_CHECKBOX_GROUP:
            case core_2.DYNAMIC_FORM_CONTROL_TYPE_GROUP:
                return 4 /* Group */;
            case core_2.DYNAMIC_FORM_CONTROL_TYPE_DATEPICKER:
                return 3 /* DatePicker */;
            case core_2.DYNAMIC_FORM_CONTROL_TYPE_INPUT:
                return 5 /* Input */;
            case core_2.DYNAMIC_FORM_CONTROL_TYPE_RADIO_GROUP:
                return 6 /* RadioGroup */;
            case core_2.DYNAMIC_FORM_CONTROL_TYPE_SELECT:
                return 7 /* Select */;
            case core_2.DYNAMIC_FORM_CONTROL_TYPE_SLIDER:
                return 8 /* Slider */;
            case core_2.DYNAMIC_FORM_CONTROL_TYPE_SWITCH:
                return 9 /* SlideToggle */;
            case core_2.DYNAMIC_FORM_CONTROL_TYPE_TEXTAREA:
                return 10 /* TextArea */;
            default:
                return null;
        }
    };
    __decorate([
        core_1.ContentChildren(core_2.DynamicTemplateDirective),
        __metadata("design:type", core_1.QueryList)
    ], DynamicMaterialFormControlComponent.prototype, "contentTemplates", void 0);
    __decorate([
        core_1.Input("templates"),
        __metadata("design:type", core_1.QueryList)
    ], DynamicMaterialFormControlComponent.prototype, "inputTemplates", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], DynamicMaterialFormControlComponent.prototype, "bindId", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DynamicMaterialFormControlComponent.prototype, "context", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", forms_1.FormGroup)
    ], DynamicMaterialFormControlComponent.prototype, "group", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], DynamicMaterialFormControlComponent.prototype, "hasErrorMessaging", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", core_2.DynamicFormControlModel)
    ], DynamicMaterialFormControlComponent.prototype, "model", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [Boolean])
    ], DynamicMaterialFormControlComponent.prototype, "showCharacterHint", null);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], DynamicMaterialFormControlComponent.prototype, "blur", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], DynamicMaterialFormControlComponent.prototype, "change", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], DynamicMaterialFormControlComponent.prototype, "focus", void 0);
    __decorate([
        core_1.ViewChild(dynamic_material_form_const_1.MD_VIEW_CHILD_SELECTOR),
        __metadata("design:type", Object)
    ], DynamicMaterialFormControlComponent.prototype, "mdViewChild", void 0);
    __decorate([
        core_1.ViewChild(material_1.MdInput),
        __metadata("design:type", Object)
    ], DynamicMaterialFormControlComponent.prototype, "mdInput", void 0);
    DynamicMaterialFormControlComponent = DynamicMaterialFormControlComponent_1 = __decorate([
        core_1.Component({
            selector: "dynamic-material-form-control,dynamic-form-material-control",
            templateUrl: "./dynamic-material-form-control.component.html"
        }),
        __metadata("design:paramtypes", [core_1.ChangeDetectorRef,
            core_2.DynamicFormValidationService])
    ], DynamicMaterialFormControlComponent);
    return DynamicMaterialFormControlComponent;
    var DynamicMaterialFormControlComponent_1;
}(core_2.DynamicFormControlComponent));
exports.DynamicMaterialFormControlComponent = DynamicMaterialFormControlComponent;
//# sourceMappingURL=dynamic-material-form-control.component.js.map